execfile('Qscan.210622_draft16.py')
this_file_path = sys._getframe().f_code.co_filename
import math
'''Path'''
datapath=r'C:\Users\Majorana\Desktop\qtlab\data\Bomin\Tin_QPC2'
filename='data'

delay1 = 1.0#delay in seconds after setting z, y, and x[0] (before an x-channel scan). Lockin: 10*tau, DC: 1
delay2 = 0.15#delay in seconds before taking data. >=1.5*tau for lockins, default 0.1

instruments_to_read = [('keithley1','1e-6V'),('lockin1','1e-6A')]#,('magnetX','Bx'),('magnetY','By')]#,('fridge','T_MC (K)'),('[xy]lockin1','1e-6A')]##, #,('Lakeshore','T (K)')]#[(a1,b1),(a2,b2),...],a is an instrument whose readings will be taken, b is a description for the reading.
colx = 1#col number for x axis. Used if is_print_cmd = True, first index is 1
coly = 4#col number for y axis. Used if is_print_cmd = True, first index is 1

# Redefine the set function
#def new_set_val(self,chan,val):
#    if self.is_dac_name(chan):
#        return ivvi.set(chan,val)
#    elif chan == 'magnet' or chan == 'magnetX':
#        return qt.instruments.get(chan).set_field(val)
#    elif chan == 'MC_SetPoint':
#        qt.instruments.get('fridge').set_I_list([0,0,0,val])
#        # if you need to wait for the stabilization
#        margin_relative = 3e-3
#        k = 0
#        tmc = qt.instruments.get('fridge').get_MC()
#        while 1:
#            if abs(tmc*1000.-val)<abs(val*margin_relative):
#                k += 1
#            else:
#                k = 0
#            if k == 2:
#                return True
#            else:
#                qt.msleep(60)
#                tmc = qt.instruments.get('fridge').get_MC()
#    return False
#get_set.set_val = new_set_val

#If using vector magnet change theta degrees here!


R = 0.1
MAX_R = 0.95

#2D
#THETA = 32

#Parallel
#THETA3D = 160 
#PHI3D = 120

#Perpendicular
#THETA3D = 70 
#PHI3D = 122

def set_val2(self,chan,val):
        '''set values of an output channel, keep update with get_val and get_rate!
        def set_magnet_3D(r,theta,phi):
            t_rad = theta/180.*math.pi
            p_rad = phi/180.*math.pi
            bx = r*math.sin(t_rad)*math.cos(p_rad)
            by = r*math.cos(t_rad)*math.sin(p_rad)
            bz = r*math.cos(r_rad)'''
        ''' In coordinates related to Wires, as wire is (r,theta,phi) in spherical coordinates,
            Let Wires direction as Bz", and it is in plane Bx"-Bz", if in plane perpendicular to wire:
            Bx = Bx"cos(phi)cos(theta) - By"sin(phi) + Bz"sin(theta)cos(phi)
            By = Bx"sin(phi)cos(theta) + By"cos(phi) + Bz"sin(theta)sin(phi)
            Bz = -Bx"sin(theta) + Bz"cos(theta)
            This scan starts from in plane Bx" = Br.'''
        def set_B_safely(x,y):
            #print '\n',x,y
            x0 = qt.instruments.get('magnetX').get_field()
            y0 = qt.instruments.get('magnetY').get_field()
            t = MAX_R*MAX_R
            if (x*x+y*y<t and x0*x0+y0*y0<t
                and x*x+y0*y0<t and x0*x0+y*y<t):
                    qt.instruments.get('magnetX').set_field(x)
                    qt.instruments.get('magnetY').set_field(y)
            else:
                print '\nError, vector out of maximum total value'
                sys.exit()
        def set_B_safely3D(x,y,z):
            #print '\n',x,y
            x0 = qt.instruments.get('magnetX').get_field()
            y0 = qt.instruments.get('magnetY').get_field()
            z0 = qt.instruments.get('magnet').get_field()
            t = MAX_R*MAX_R
            if (x*x+y*y+z*z<t and x0*x0+y0*y0+z0*z0<t
                and x*x+y0*y0+z*z<t and x0*x0+y*y+z*z and x*x+y*y+z0*z0<t
                and x0*x0+y0*y0+z*z<t and x0*x0+y*y+z0*z0<t and x*x+y0*y0+z0*z0<t):
                    qt.instruments.get('magnetX').set_field(x)
                    qt.instruments.get('magnetY').set_field(y)
                    qt.instruments.get('magnet').set_field(z)
            else:
                print '\nError, vector out of maximum total value'
                sys.exit()
        if self.is_dac_name(chan):
            #print 'setting %s to %f'%(chan,val)
            ivvi.set(chan,val)
        elif chan == 'magnet' or chan == 'magnetX' or chan == 'magnetY':
            #print 'setting B to %f'%(val)
            qt.instruments.get(chan).set_field(val)
        elif chan == 'magnetR':
            t_rad = THETA/180.*math.pi
            x = val*math.cos(t_rad)
            y = val*math.sin(t_rad)
            set_B_safely(x,y)
        elif chan == 'magnetTheta':
            t_rad = val/180.*math.pi
            x = R*math.cos(t_rad)
            y = R*math.sin(t_rad)
            set_B_safely(x,y)
        elif chan == 'magnetR3D':
            t_rad = THETA3D/180.*math.pi
            p_rad = PHI3D/180.*math.pi
            x = val*math.sin(t_rad)*math.cos(p_rad)
            y = val*math.sin(t_rad)*math.sin(p_rad)
            z = val*math.cos(t_rad)
            set_B_safely3D(x,y,z)
        elif chan == 'magnetTheta3D':
            t_rad = val/180.*math.pi
            p_rad = PHI3D/180.*math.pi
            x = R3D*math.sin(t_rad)*math.cos(p_rad)
            y = R3D*math.sin(t_rad)*math.sin(p_rad)
            z = R3D*math.cos(t_rad)
            set_B_safely3D(x,y,z)
        elif chan == 'magnetPhi3D':
            t_rad = THETA3D/180.*math.pi
            p_rad = val/180.*math.pi
            x = R3D*math.sin(t_rad)*math.cos(p_rad)
            y = R3D*math.sin(t_rad)*math.sin(p_rad)
            z = R3D*math.cos(t_rad)
            set_B_safely3D(x,y,z)
        elif chan == 'magnetPerpendicular3D':
            a_rad = val/180.*math.pi
            t_rad = THETA3D/180.*math.pi
            p_rad = PHI3D/180.*math.pi
            Bx_new = R3D*math.cos(a_rad)
            By_new = R3D*math.sin(a_rad)
            x =  Bx_new*math.cos(p_rad)*math.cos(t_rad)-By_new*math.sin(p_rad)
            y =  Bx_new*math.sin(p_rad)*math.cos(t_rad)+By_new*math.cos(p_rad)
            z = -Bx_new*math.sin(t_rad)
            set_B_safely3D(x,y,z)            
            
            
        


get_set.set_val = set_val2

g = get_set()
#g.add_lockin_conductance({'index':1,'label':'2e2/h','Rin':7.04e3,'lockin_osc':0.5*0.01,'Vrange':0.01,'Igain':1.e6})
e = easy_scan()

#MEASUREMENTS
# bwd=True: sweep back after each line; xswp_by_mchn=FALSE or TRUE: usually not used
###1d
#e.scan('Vbias(*10uV)','dac1',300,-300,600)
#e.scan('Vbias(*10uV)','dac1',300,-300,200)
#e.scan('Vbias(*10uV)','dac1',-300,0,100)
#e.scan(['g1(*5mV)','g2(*5mV)'],['dac11','dac12'],[0]*2,[-500]*2,100)
#e.scan(['g1(*5mV)','g2(*5mV)'],['dac11','dac12'],[-1000]*2,[1000]*2,1000)
#e.scan(['g1(*5mV)','g2(*5mV)'],['dac11','dac12'],[1000]*2,[-1000]*2,1000)
#e.scan(['g1(*5mV)','g2(*5mV)'],['dac11','dac12'],[-1000]*2,[1000]*2,1000)
#e.scan(['g1(*5mV)','g2(*5mV)'],['dac11','dac12'],[1000]*2,[0]*2,500)
#e.scan('g1(*5mV)','dac11',0,-200,200)
#e.scan('g1(*5mV)','dac11',-300,-200,50)
#e.scan('g1(*5mV)','dac11',-1000,-2000,500)
#e.scan('Vbias(*10uV), Vac(50uV)','dac1',300,-300,600,'g1(*5mV)','dac11',300,-600,300)
#e.scan('Vbias(*10uV)','dac1',200,-200,400,'field(T)','magnet',2,-2,400)
#e.scan('field(T)','magnetR3D',0,0.05,10)
#e.scan('g2(*5mV)','dac12',0,300,200)
#e.scan('Ibias(*1nA), Iac=5nA','dac2',200,-200,200)

#e.scan('Vbias(*10uV) Vac = 50uV','dac1',600,-300,300,'field(T)','magnet',2,0,200)
#e.scan('Ibias(*1nA, Iac=5nA)','dac2',200,-200,300,'g1(*5mV)','dac11',0,500,200)

#e.scan('g1(*5mV)','dac11',-200,-400,200)
#e.scan('Ibias(*1nA), Iac=5nA','dac2',100,-100,100,'field(T)','magnet',-0.5,0.5,100)
#e.scan('g1(*5mV)','dac11',-400,0,200)
#e.scan('Ibias(*1nA), Iac=5nA','dac2',300,-300,300,'field(T)','magnet',0.5,-0.5,100)
#e.scan('g1(*5mV)','dac11',0,200,200)
#e.scan('Ibias(*1nA), Iac=5nA','dac2',300,-300,300,'field(T)','magnet',-0.5,0.5,100)
#e.scan('g1(*5mV)','dac11',200,500,200)
#e.scan('Ibias(*1nA), Iac=5nA','dac2',300,-300,300,'field(T)','magnet',0.5,-0.5,100)
#e.set('ivvi',0)
#e.scan('field(T)','magnet',-0.5,0,50)
#e.scan('g1(*5mV)','dac11',0,-800,400,'field(T)','magnet',-0.3,5,212)


#XY Rotating
#e.scan('g1(*5mV)','dac11',0,-400,200)
#e.scan(['g1(*5mV)','g2(*5mV)'],['dac11','dac12'],[200]*2,[300]*2,100)
#e.scan('theta(degree)','magnetTheta',90,0,100)
#e.scan('Ibias(*0.1nA), Iac=0.5nA','dac2',300,-300,150,'theta(degree)','magnetTheta',0,720,360)
#e.scan('Ibias(*1nA), Iac=5nA','dac2',100,-100,100,'theta(degree)','magnetTheta',32,0,32)
#e.set('magnetX',0)
#e.set('magnetY',0)
#e.set('magnet',0)
#e.set('ivvi',0)
#e.set('magnetR',0.1)
#e.set('magnet',0.5)
#e.scan('Ibias(*1nA), Iac=5nA','dac2',100,-100,100,'field(T)','magnet',0.5,-0.5,100)
#e.scan('field(T)','magnetX',0.025,0.075,10)
#e.scan('field(T)','magnetR',0,0.05,1)
#e.scan('g1(*5mV)','dac11',0,-200,200)
#e.scan('Ibias(*1nA), Iac=5nA','dac2',150,-150,300,'theta(degree)','magnetTheta',60,50,20)


#XYZ 3D
#e.scan('g1(*5mV)','dac11',0,-400,200)
#THETA3D = 90
#PHI3D = 115
#e.scan('Ibias(*0.1nA), Iac=0.5nA','dac2',400,-400,200,'field(T)','magnetR3D',0.3,-0.3,60)
THETA3D = 270
PHI3D = 115
e.scan('Ibias(*0.1nA), Iac=0.5nA','dac2',400,-400,200,'field(T)','magnetR3D',0.2,-0.2,40)
THETA3D = 80
PHI3D = 120
e.scan('Ibias(*0.1nA), Iac=0.5nA','dac2',400,-400,200,'field(T)','magnetR3D',0.2,-0.2,40)
THETA3D = 260
PHI3D = 120
e.scan('Ibias(*0.1nA), Iac=0.5nA','dac2',400,-400,200,'field(T)','magnetR3D',0.2,-0.2,40)
#e.scan('Ibias(*1nA), Iac=5nA','dac2',400,-400,200,'theta(degree)','magnetTheta3D',0,720,360)
#e.scan('g1(*5mV)','dac11',0,-400,100)
#e.scan('field(T)','magnetR3D',0,-0.5,10)
#e.scan('Ibias(*0.1nA), Iac=0.5nA','dac2',400,-400,100,'alpha(degree)','magnetPerpendicular3D',0,720,180)
#THETA3D = 160
#PHI3D = 120
#R3D = 0.15
#e.scan('Ibias(*0.1nA), Iac=0.5nA','dac2',200,-200,50,'alpha(degree)','magnetPerpendicular3D',0,360,90)
#R3D = 0.1
#e.scan('Ibias(*0.1nA), Iac=0.5nA','dac2',300,-300,150,'alpha(degree)','magnetPerpendicular3D',0,720,360)
#e.scan('Ibias(*1nA), Iac=5nA','dac2',100,-100,100,'theta(degree)','magnetTheta3D',140,190,25)
#e.scan('Ibias(*1nA), Iac=5nA','dac2',100,-100,100,'Phi(degree)','magnetPhi3D',100,150,25)
#e.scan('Ibias(*1nA), Iac=5nA','dac2',75,100,25)
#e.scan('field(T)','magnetR3D',0,0.9,90)
#e.scan('Ibias(*1nA), Iac=5nA','dac2',-75,75,200)
#e.scan('field(T)','magnetR3D',0.2,-0.2,80)
#e.scan('field(T)','magnetR3D',0.03,0.03,20)
#e.scan('field(T)','magnetR3D',-0.07,-0.07,20)
#e.scan('Ibias(*0.1nA), Iac=0.5nA','dac2',600,-600,300,'field(T)','magnetR3D',0.4,-0.4,160)
#e.scan('Ibias(*1nA), Iac=5nA','dac2',100,-100,200,'field(T)','magnetR3D',0.9,-0.1,100)
e.set('ivvi',0)
e.set('magnet',0)
e.set('magnetX',0)
e.set('magnetY',0)
#THETA3D = 70
#PHI3D = 120
#e.scan('Ibias(*1nA), Iac=5nA','dac2',200,-200,200,'field(T)','magnetR3D',0.6,-0.6,120)

#Tc measurement
#e.scan('T_set(K)','Lakeshore',10,5,200)
#e.scan('time1 (s)','time',0,100,50)
#t0 = time();e.scan('t (s)','time',time()-t0,time()-t0+3600*2,1,xswp_by_mchn=True)
#chns=range(1,17);e.scan(['g%d'%x for x in chns],['dac%d'%x for x in chns],[10 for x in chns],[0 for x in chns],50)
#while 1:
#    e.scan('Ibias(*1uA)','dac1',100,-100,200,'x','x',0,1,300,bwd=True)
#e.scan('Ibias(*1uA), Iac(0.5uA)','dac2',200,-200,400,'MC(mK)','MC_SetPoint',4000,1150,59,bwd=True)
#e.scan('Ibias(*0.01nA)','dac2',200,-200,400,'g1(*5mV)','dac10',0,1000,200)
#e.scan('MC(mK)','MC_SetPoint',1160,1150,10)
#e.set('MC_SetPoint',1170,1150,2)

##02/24/19
#e.scan('field(T)','magnet',2,0,200)
#e.scan('Vbias(*0.01mV)','dac1',0,1500,500)
#e.scan('g2(*5mV)','dac12',180,200,400)
#e.scan('Vbias(*0.01 mV),Vac = 10uV','dac1',50,-50,100,'bg','dac2',-1800,-2000,100)
#e.scan('Vbias(*0.01 mV),Vac = 50uV','dac1',1500,-1500,600,['bg(*5mV)','g1(*5mV)'],['dac2','dac3'],[2000]*2,[1000]*2,400)
# e.scan('Vbias(*0.01 mV), Vac = 10uV','dac1',300,-300,600,'g1(*5mV)','dac3',1000,0,1000)
#e.scan('Vbias(*0.01mV)','dac1',-1500,100,1600)
#e.scan('g2(*5mV)','dac12',0,150,150)
#e.scan('g2(*5mV)','dac12',150,0,300,'field(T)','magnet',5,-0.1,510)

#e.scan('time','time',0,3600,3600)


#e.scan('Ibias(*0.01nA)','dac1',400,-400,400,'g2','dac12',50,70,40)
###2d
#e.scan('Vbias(*0.01mV)','dac1',1000,200,400)
#e.scan('Vbias(*0.01 mV),Vac = 10uV','dac1',1000,-1000,500,['g1(*5mV)','g2(*5mV)','g3(*5mV)'],['dac11','dac12','dac13'],[300]*3,[0]*3,100)
#e.scan('Ibias((0.1nA)','dac1',200,-200,600,['g1(*5mV)','g2(*5mV)','g3(*5mV)'],['dac11','dac12','dac13'],[50]*3,[400]*3,175)
#e.scan('Vbias(*0.01 mV),Vac = 10uV','dac1',200,-200,200,['g1(*5mV)','g2(*5mV)','g3(*5mV)'],['dac11','dac12','dac13'],[150]*3,[50]*3,100)
#e.scan(['g1(*5mV)','g2(*5mV)'],['dac11','dac12'],[500]*2,[100]*2,200,'g3(*5mV)','dac13',500,100,200)
#e.scan('g2','dac12',400,100,300,'g1','dac11',650,750,100)
#e.scan('g1(*5mV)','dac11',500,100,500)
#e.scan('g2(*5mV)','dac12',100,457,1000)
#e.scan('g3(*5mV)','dac13',-150,600,500)
#e.scan('g1(*5mV)','dac11',600,-100,350,'g3(*5mV)','dac13',600,-100,350)
#e.scan('g1(*5mV)','dac11',-150,600,500)
#e.scan('g2(*5mV)','dac12',-150,50,100)
#e.scan('g3(*5mV)','dac13',-150,600,500)
#e.scan('g2','dac12',400,-200,600,['g1(*5mV)','g3(*5mV)'],['dac11','dac13'],[600]*2,[1000]*2,400)
#e.scan('g1(*5mV)','dac11',-120,1000,1000)
#e.scan('g3(*5mV)','dac13',-110,200,500)
#e.scan(['g1(*5mV)','g2(*5mV)'],['dac11','dac12'],[500]*2,[100]*2,400,'g3(*5mV)','dac13',190,210,20)
#e.scan(['Vdc,*0.01 mV'],['dac1'],[100],[-100],100,     ['repeat'],['repeat'],[0],[1],20, bwd=True)
#e.scan('Ibias(*0.1nA)','dac1',3000,-3000,1000,'g3(*5mV)','dac13',140,120,20)
#e.scan('Vdc, *0.01mV,Vac=5uV','dac1',150,-150,200,'field(T)','magnet',0,1,100)
#e.scan(['g1(*1mV)','g2(*1mV)','g3(*1mV)'],['dac11','dac12','dac13'],[300]*3,[256]*3,100)
#e.scan('field(T)','magnet',0.08,-0.1,18)
#e.scan('Ibias(*0.1nA)','dac1',400,-400,1200,'field(T)','magnet',-0.1,2,105)
#e.scan(['g1(*1mV)','g2(*1mV)','g3(*1mV)'],['dac11','dac12','dac13'],[400]*3,[500]*3,200)
#e.scan('Ibias(*0.1nA)','dac1',500,-500,500,'field(T)','magnet',-0.1,0.5,40)
#e.scan('g2(*5mV)','dac12',400,100,600,'field(T)','magnet',3,-0.1,310)
#e.scan(['g2(*5mV)','g3(*5mV)'],['dac12','dac13'],[300]*2,[100]*2,400,'field(T)','magnet',3,-0.1,300)
#e.scan('Bg(*15mV)','dac3',100,300,1000)
#e.scan('Vbias(*0.01 mV),Vac = 5uV','dac1',2000,-2000,800,'Bg(*15mV)','dac3',300,100,200)



#e.scan('Bg(*15mV)','dac3',287,200,200)
#e.scan('Ibias(*0.1nA)','dac1',300,-300,600,'Vbg(*15mV)','dac3',250,350,100)
#e.scan('field(T)','magnet',0.1,0.15,100)
#e.scan('Bg(*15mV)','dac3',350,180,200)
#e.scan('Ibias(*0.1nA)','dac1',300,-300,600,'Vbg(*15mV)','dac3',180,350,170)


#e.scan('Ibias(*0.01nA)','dac1',200,-200,500,'field(T)','magnet',-0.1,0.5,120)
#e.scan('time1 (s)','time',0,100,100,'time2 (s)','time',0,100,100)
###3d
#e.scan(['g1'],['dac1'],[0],[3],10,     ['g3'],['dac3'],[0],[3],10,     ['g5'],['dac5'],[0],[3],10)